/*
    Ming, an SWF output library
    Copyright (C) 2001  Opaque Industries - http://www.opaque.net/

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* output.h */

#ifndef SWF_OUTPUT_H_INCLUDED
#define SWF_OUTPUT_H_INCLUDED

#include "libswf.h"
#include "method.h"

#define OUTPUT_BUFFER_INCREMENT 1024

struct _output
{
  struct _output *next;
  byte *buffer;
  byte *pos;
  int buffersize;
  int free;
  int bitpos;
};
typedef struct _output *SWFOutput;

#define OUTPUT_SIZE sizeof(struct _output)

/* create/destroy output object */
WM_DLL_A SWFOutput WM_DLL_B newSWFOutput();
WM_DLL_A SWFOutput WM_DLL_B newSizedSWFOutput(int size);
WM_DLL_A void WM_DLL_B destroySWFOutput(SWFOutput out);

/* write output's buffer to stream */
WM_DLL_A void WM_DLL_B SWFOutput_writeToMethod(SWFOutput out,
			     SWFByteOutputMethod method, void *data);

/* utilities for writing */
WM_DLL_A void WM_DLL_B SWFOutput_grow(SWFOutput out);
WM_DLL_A void WM_DLL_B SWFOutput_checkSize(SWFOutput out, int bytes);
WM_DLL_A void WM_DLL_B SWFOutput_byteAlign(SWFOutput out);

WM_DLL_A int WM_DLL_B  SWFOutput_length(SWFOutput out);

/* write data to output */
WM_DLL_A void WM_DLL_B SWFOutput_writeBits(SWFOutput out, int data, int bits);
WM_DLL_A void WM_DLL_B SWFOutput_writeSBits(SWFOutput out, int data, int bits);
WM_DLL_A void WM_DLL_B SWFOutput_writeUInt8(SWFOutput out, int data);
WM_DLL_A void WM_DLL_B SWFOutput_writeSInt8(SWFOutput out, int data);
WM_DLL_A void WM_DLL_B SWFOutput_writeUInt16(SWFOutput out, int data);
WM_DLL_A void WM_DLL_B SWFOutput_writeSInt16(SWFOutput out, int data);
WM_DLL_A void WM_DLL_B SWFOutput_writeUInt32(SWFOutput out, long data);
WM_DLL_A void WM_DLL_B SWFOutput_writeSInt32(SWFOutput out, long data);
WM_DLL_A void WM_DLL_B SWFOutput_writeBuffer(SWFOutput out, char *buffer, int bytes);

/* number of bits required to store num */
WM_DLL_A int WM_DLL_B SWFOutput_numBits(int num);
WM_DLL_A int WM_DLL_B SWFOutput_numSBits(int num);

WM_DLL_A void WM_DLL_B SWFOutput_writeString(SWFOutput out, const byte *string);

WM_DLL_A void WM_DLL_B SWFOutput_writeTo_fputc(SWFOutput out,
				      FILE *data);

#endif /* SWF_OUTPUT_H_INCLUDED */

