/*
    Ming, an SWF output library
    Copyright (C) 2001  Opaque Industries - http://www.opaque.net/

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>

#include "blocks/swf.h"

#include "movie.h"
#include "displaylist.h"
#include "fill.h"
#include "shape_util.h"
#include "text_util.h"

extern float Ming_scale;
extern int Ming_cubicThreshold;
extern int SWF_versionNum;

WM_DLL_A int WM_DLL_B Ming_init();
WM_DLL_A int WM_DLL_B Ming_cleanup();

/* Change the scale, the scale, change it, yeah.  default is 20. */

WM_DLL_A void WM_DLL_B Ming_setScale(float scale);
WM_DLL_A float WM_DLL_B Ming_getScale(void);


/* sets the threshold error for drawing cubic beziers.  Lower is more
   accurate, hence larger file size. */

WM_DLL_A void WM_DLL_B Ming_setCubicThreshold(int num);


/* change the error/warn behavior */

WM_DLL_A void WM_DLL_B Ming_setWarnFunction(void (*warn)(char *msg, ...));
WM_DLL_A void WM_DLL_B Ming_setErrorFunction(void (*error)(char *msg, ...));


/* set the version number to use */

WM_DLL_A void WM_DLL_BMing_useSWFVersion(int version);


/* stupid redef problem if we just include movieclip.h */

typedef void *SWFMovieClip;

WM_DLL_A void WM_DLL_B destroySWFMovieClip(SWFMovieClip clip);
SWFMovieClip newSWFMovieClip();

WM_DLL_A void WM_DLL_B SWFMovieClip_setNumberOfFrames(SWFMovieClip clip, int frames);
WM_DLL_A SWFDisplayItem WM_DLL_B SWFMovieClip_add(SWFMovieClip clip, SWFBlock block);
WM_DLL_A void WM_DLL_B SWFMovieClip_remove(SWFMovieClip clip, SWFDisplayItem item);
WM_DLL_A void WM_DLL_B SWFMovieClip_nextFrame(SWFMovieClip clip);
WM_DLL_A void WM_DLL_B SWFMovieClip_labelFrame(SWFMovieClip clip, char *label);

WM_DLL_A int WM_DLL_B SWFMovieClip_output(SWFMovieClip clip, SWFByteOutputMethod method, void *data);

WM_DLL_A void WM_DLL_B MingRemoveAllDestructibleBlocks(void);
WM_DLL_A int WM_DLL_B Ming_MemLeakCheckAndFree(void);